package com.lantone.qc.trans.ywzxyy.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.dbanaly.facade.ywzxyy.YwzxyyXmlUtil;
import com.lantone.qc.pub.util.StringUtil;
import com.lantone.qc.trans.comsis.CommonAnalysisUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2021/1/25 14:04
 */
@Slf4j
public class YwzxyyBeHospitalizedXmlAnalysis implements YwzxyyXmlAnalysis {

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> ret = null;
        String xml = args[0];
        String recTitle = args[1];
        String recTypeId = args[2];
        if (recTitle.equals("住院病历")) {
            ret = zybl(xml);
        } else if (recTitle.equals("术前讨论记录")) {

        } else if (recTitle.equals("术前讨论兼术前小结")) {

        }
        return ret;
    }

    private Map<String, String> zybl(String xml) {
        Map<String, String> structureMap = Maps.newHashMap();
        try {
            xml = xml.replace("(<慢性疾病>)[\\s\\S]*(</既往病史>)", "</既往病史>")
                    .replace("(<传染病名称>)[\\s\\S]*(</传染病史>)", "</传染病史>")
                    .replace("(<经量>)[\\s\\S]*(</月经史>)", "</月经史>")
                    .replace("(<近亲结婚否>)[\\s\\S]*(</婚姻情况>)", "</婚姻情况>")
                    .replace("(<足月产次数>)[\\s\\S]*(</生育情况>)", "</生育情况>")
                    .replace("(<收缩压值>)[\\s\\S]*(</血压>)", "</血压>")
                    .replace("(<反射程度>)[\\s\\S]*(</深反射>)", "</深反射> ")
                    .replace("(<肌张力>)[\\s\\S]*(<肌张力>)", "<肌张力><肌张力>").replace("(</肌张力>)[\\s\\S]*(</肌张力>)", "</肌张力></肌张力> ")
                    .replace("(<肌力>)[\\s\\S]*(<肌力>)", "<肌力><肌力>").replace("(</肌力>)[\\s\\S]*(</肌力>)", "</肌力></肌力> ");
            String text = YwzxyyXmlUtil.xml2Txt(xml);
            List<String> titles = CommonAnalysisUtil.sortTitlesNoColon(
                    Lists.newArrayList("姓　　名", "姓　　名", "性    别", "年    龄", "民    族", "婚    姻", "出 生 地",
                            "职    业", "联系地址", "入院时间", "病史陈述者", "记录日期", "主    诉", "现 病 史", "既 往 史", "个 人 史",
                            "月 经 史", "婚 育 史", "家 族 史", "辅助检查", "营养风险筛查", "初步诊断", "修正诊断", "补充诊断",
                            "医师签名", "记录时间", "体格检查（一）", "体格检查表(二)补 充 及 专 科 情 况", "体格检查", "检查医师"),
                    text
            );
            CommonAnalysisUtil.cutByTitlesNoColon(text, titles, 0, structureMap);
            structureMap = keyRemoveBlank(structureMap);
            structureMap.put("体格检查", structureMap.get("体格检查（一）"));
            structureMap.put("专科检查", structureMap.get("体格检查表(二)补充及专科情况"));
            structureMap.remove("体格检查（一）");
            structureMap.remove("体格检查表(二)补充及专科情况");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
        return structureMap;
    }

    private Map<String, String> keyRemoveBlank(Map<String, String> sourceMap) {
        Map<String, String> structureMap = Maps.newHashMap();
        sourceMap.forEach((key, value) -> {
            structureMap.put(StringUtil.removeBlank(key), sourceMap.get(key));
        });
        return structureMap;
    }

}